
from basics import *

def TakeItem(I,u):
   if type(I) == ArrayType: I = I[u]
   elif type(I) == ListType: I = [I[j] for j in u]
   return I

def TakeDictionary(D,u):
   U = {}
   for k in D: U[k] = TakeItem(D[k],u)
   return U

def CompressItem(I,u):
   if type(I) == ArrayType: I = I[nonzero(u)]
   elif type(I) == ListType: I = [I[j] for j in nonzero(u)]
   return I

def CompressDictionary(D,u):
   U = {}
   for k in D: U[k] = CompressItem(D[k],u)
   return U

def ConcatenateItem(I1,I2):
   if type(I1) == ArrayType: I = concatenate([I1,I2])
   elif type(I1) == ListType: I = I1+I2
   return I

def ConcatenateDictionary(D1,D2):
   U = {}
   for k in D1: U[k] = ConcatenateItem(D1[k],D2[k])
   return U

