
import h5py
from basics import *

class gTable:
    def __init__(self,hname,verb=0):
        self.verb =  verb
        self.h5file = h5py.File(hname, "r")
        self.data = self.pull(self.h5file)
    def __repr__(self):
        lines = ["%r:" % (self.h5file)]
        for key,val in self.data.items():
            lines.append("%r:%r"%(key,val))
        return "\n".join(lines)
    def pull(self,node):
        data = {}
        for key,val in node.items():
            if self.verb: print key,val
            if hasattr(val,"keys"):
               data[key] = self.pull(val)
               if self.verb: print data
            else:
               data[key] = val
            if self.verb: print
        return data
    def close(self):
        self.h5file.close()

